import wx
import wx.xrc
import word_process as word
import two_class_compare as c_2
import multi_class_compare as c_m

import matplotlib.gridspec as gridspec
from sklearn.externals import joblib
from pylab import *

mpl.rcParams['font.sans-serif'] = ['SimHei']

two_class_result = []
multi_class_result = []


class Sentiment_analysis(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=u"Sentiment Analysis", pos=wx.DefaultPosition,
                          size=wx.Size(436, 670), style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        self.SetSizeHintsSz(wx.DefaultSize, wx.DefaultSize)

        bSizer1 = wx.BoxSizer(wx.VERTICAL)

        # 操作提示界面定义
        self.m_textCtrl1 = wx.TextCtrl(self, wx.ID_ANY, u"tips:\n可以选择文件进行情感分析，也可以手动输入文本进行分析\n"
                                                        u"一、选择文件进行分析\n1. 选择需要进行情感分析的文件\n"
                                                        u"2. 点击按钮生成相应的情感分析结果\n"
                                                        u"二、输入文本进行分析\n1. 输入需要进行情感分析的文本\n"
                                                        u"2. 点击各算法生成相应的情感分析结果",
                                       wx.DefaultPosition, wx.Size(500, 150), wx.TE_MULTILINE | wx.TE_READONLY)
        bSizer1.Add(self.m_textCtrl1, 0, wx.ALL | wx.EXPAND, 5)

        # 训练文件选择界面定义
        self.select_train_file = wx.StaticText(self, wx.ID_ANY, u"请选择训练文件：", wx.DefaultPosition, wx.DefaultSize, 0)
        self.select_train_file.Wrap(-1)
        self.select_train_file.SetFont(wx.Font(wx.NORMAL_FONT.GetPointSize(), 70, 90, 92, False, wx.EmptyString))
        self.select_train_file.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.select_train_file.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_3DLIGHT))
        bSizer1.Add(self.select_train_file, 0, wx.ALL, 5)

        self.pick_train_file = wx.FilePickerCtrl(self, wx.ID_ANY, wx.EmptyString, u"Select a file", u"*.*",
                                           wx.DefaultPosition, wx.Size(500, -1), wx.FLP_DEFAULT_STYLE)
        bSizer1.Add(self.pick_train_file, 0, wx.ALL | wx.EXPAND, 5)

        classify = wx.GridSizer(1, 2, 1, 0)

        # 二分类按钮定义
        self.two_classify = wx.Button(self, wx.ID_ANY, u"二分类", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.two_classify.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.two_classify.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        classify.Add(self.two_classify, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND, 5)

        # 多分类按钮定义
        self.multi_classify = wx.Button(self, wx.ID_ANY, u"多分类", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.multi_classify.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.multi_classify.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        classify.Add(self.multi_classify, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND, 5)

        bSizer1.Add(classify, 1, wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND, 1)

        # 测试文件选择界面定义
        self.select_test_file = wx.StaticText(self, wx.ID_ANY, u"请选择测试文件：", wx.DefaultPosition, wx.DefaultSize, 0)
        self.select_test_file.Wrap(-1)
        self.select_test_file.SetFont(wx.Font(wx.NORMAL_FONT.GetPointSize(), 70, 90, 92, False, wx.EmptyString))
        self.select_test_file.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.select_test_file.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_3DLIGHT))
        bSizer1.Add(self.select_test_file, 0, wx.ALL, 5)

        self.pick_test_file = wx.FilePickerCtrl(self, wx.ID_ANY, wx.EmptyString, u"Select a file", u"*.*",
                                                 wx.DefaultPosition, wx.Size(500, -1), wx.FLP_DEFAULT_STYLE)
        bSizer1.Add(self.pick_test_file, 0, wx.ALL | wx.EXPAND, 5)

        test_classify = wx.GridSizer(1, 2, 1, 0)

        # 二分类按钮定义
        self.test_two_classify = wx.Button(self, wx.ID_ANY, u"二分类", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.test_two_classify.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.test_two_classify.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        test_classify.Add(self.test_two_classify, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND,
                     5)

        # 多分类按钮定义
        self.test_multi_classify = wx.Button(self, wx.ID_ANY, u"多分类", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.test_multi_classify.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.test_multi_classify.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        test_classify.Add(self.test_multi_classify, 0,
                     wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND, 5)

        bSizer1.Add(test_classify, 1, wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND, 1)

        # 输入文本的框定义
        test_text = wx.StaticBoxSizer(wx.StaticBox(self, wx.ID_ANY, u"请输入需要分析的文本"), wx.VERTICAL)
        self.text_analysis = wx.TextCtrl(self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size(500, 100),
                                         wx.TE_MULTILINE)
                                         #wx.TE_MULTILINE | wx.HSCROLL)
        test_text.Add(self.text_analysis, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL | wx.EXPAND | wx.ALIGN_RIGHT, 5)
        bSizer1.Add(test_text, 1, wx.EXPAND | wx.LEFT, 5)

        # 贝叶斯二分类按钮定义
        two_class_classify = wx.GridSizer(1, 3, 1, 0)
        self.two_class_Bayes = wx.Button(self, wx.ID_ANY, u"two_class_Bayes", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.two_class_Bayes.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.two_class_Bayes.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        two_class_classify.Add(self.two_class_Bayes, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # SVM二分类按钮定义
        self.two_class_SVM = wx.Button(self, wx.ID_ANY, u"two_class_SVM", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.two_class_SVM.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.two_class_SVM.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        two_class_classify.Add(self.two_class_SVM, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # Adaboost二分类按钮定义
        self.two_class_Adaboost = wx.Button(self, wx.ID_ANY, u"two_class_Adaboost", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.two_class_Adaboost.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.two_class_Adaboost.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        two_class_classify.Add(self.two_class_Adaboost, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # 添加GridSizer到整体布局中
        bSizer1.Add(two_class_classify, 1, wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND, 1)

        self.two_classify_result = wx.Button(self, wx.ID_ANY, u"二分类结果对比", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.two_classify_result.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.two_classify_result.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        bSizer1.Add(self.two_classify_result, 0,
                    wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND, 5)

        multi_class_classify = wx.GridSizer(1, 3, 1, 0)

        # 贝叶斯多分类按钮定义
        self.multi_class_Bayes = wx.Button(self, wx.ID_ANY, u"multi_class_Bayes", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.multi_class_Bayes.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.multi_class_Bayes.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        multi_class_classify.Add(self.multi_class_Bayes, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # SVM多分类按钮定义
        self.multi_class_SVM = wx.Button(self, wx.ID_ANY, u"multi_class_SVM", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.multi_class_SVM.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.multi_class_SVM.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        multi_class_classify.Add(self.multi_class_SVM, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # Adaboost多分类按钮定义
        self.multi_class_Adaboost = wx.Button(self, wx.ID_ANY, u"multi_class_Adaboost", wx.Point(-1, -1), wx.Size(150, 30), 0)
        self.multi_class_Adaboost.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.multi_class_Adaboost.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        multi_class_classify.Add(self.multi_class_Adaboost, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_BOTTOM, 5)

        # 添加GridSizer到整体布局中
        bSizer1.Add(multi_class_classify, 1, wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND, 1)

        self.multi_classify_result = wx.Button(self, wx.ID_ANY, u"多分类结果对比", wx.Point(-1, -1), wx.Size(200, 30), 0)
        self.multi_classify_result.SetForegroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNTEXT))
        self.multi_classify_result.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BTNFACE))
        bSizer1.Add(self.multi_classify_result, 0,wx.LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND, 5)


        self.SetSizer(bSizer1)
        self.Layout()

        self.Centre(wx.BOTH)

        # Connect Events
        self.pick_train_file.Bind(wx.EVT_FILEPICKER_CHANGED, self.choose_file)
        self.two_classify.Bind(wx.EVT_BUTTON, self.file_2_class)
        self.multi_classify.Bind(wx.EVT_BUTTON, self.file_m_class)

        # Connect Events
        self.pick_test_file.Bind(wx.EVT_FILEPICKER_CHANGED, self.choose_test_file)
        self.test_two_classify.Bind(wx.EVT_BUTTON, self.test_file_2_class)
        self.test_multi_classify.Bind(wx.EVT_BUTTON, self.test_file_m_class)

        # 二分类按钮事件绑定
        self.two_class_Bayes.Bind(wx.EVT_BUTTON, self.two_Bayes)
        self.two_class_SVM.Bind(wx.EVT_BUTTON, self.two_SVM)
        self.two_class_Adaboost.Bind(wx.EVT_BUTTON, self.two_Adaboost)
        self.two_classify_result.Bind(wx.EVT_BUTTON, self.two_c_result)

        # 多分类按钮事件绑定
        self.multi_class_Bayes.Bind(wx.EVT_BUTTON, self.multi_Bayes)
        self.multi_class_SVM.Bind(wx.EVT_BUTTON, self.multi_SVM)
        self.multi_class_Adaboost.Bind(wx.EVT_BUTTON, self.multi_Adaboost)
        self.multi_classify_result.Bind(wx.EVT_BUTTON, self.multi_c_result)

        self.text_analysis.Bind(wx.EVT_TEXT_ENTER, self.text_get)

        def __del__(self):
            pass

    # Virtual event handlers, overide them in your derived class

    def choose_file(self, event):
        global train_file_path
        train_file_path = self.pick_train_file.GetPath()
        print(train_file_path)
        return 0

    def choose_test_file(self, event):
        global test_file_path
        test_file_path = self.pick_test_file.GetPath()
        print(test_file_path)
        return 0

    def load_text(self, mode):
        # 获取关键词
        vocabList = word.build_key_word(train_file_path)
        # 获取分词和标签
        if mode == "train":
            line_cut, label = word.loadDataSet(train_file_path, mode)
            train_mood_array = word.setOfWordsListToVecTor(vocabList, line_cut)
            test_word_array = []
            test_word_arrayLabel = []
            testCount = 100
            # 从中随机选取100条用来测试，并删除原来的位置
            for i in range(testCount):
                try:
                    randomIndex = np.random.randint(0, len(train_mood_array))
                    test_word_arrayLabel.append(label[randomIndex])
                    test_word_array.append(train_mood_array[randomIndex])
                    del (train_mood_array[randomIndex])
                    del (label[randomIndex])
                except Exception as e:
                    print(e)
            return train_mood_array, label, test_word_array, test_word_arrayLabel, vocabList, testCount
        elif mode == "test":

            line_cut, label = word.loadDataSet(test_file_path, mode)
            test_array = word.setOfWordsListToVecTor(vocabList, line_cut)
            return test_array, label

        elif mode == "text":
            line_cut = word.loadDataSet(text, mode)
            return vocabList, line_cut

    def file_2_class(self,event):
        Bayes_error = []
        SVM_err = []
        ada_real_err = []

        bayes_time = []
        adaboost_time = []
        SVM_time = []

        testCount = 100
        for m in range(1, 11):
            print('第 %d 次测试' % m)
            train_mood_array, label, test_word_array, test_word_arrayLabel, vocabList, testCount = self.load_text("train")

            # 1.利用sklearn中的多项式贝叶斯进行分类并计算分类错误率
            mul, count, time = c_2.Bayes_error(train_mood_array, label, test_word_array, test_word_arrayLabel)
            ErrorRate_bayes1 = count / float(testCount)
            print('多项式Bayes错误率为 %f' % ErrorRate_bayes1)
            Bayes_error.append(ErrorRate_bayes1)
            bayes_time.append(time / float(testCount))

            # 2. 利用SVM进行分类并计算分类错误率
            tmp, time = c_2.SVM_error(train_mood_array, label, test_word_array, test_word_arrayLabel)
            ErrorRate_svm = tmp/ testCount
            print('SVM错误率为 %f' % ErrorRate_svm)
            SVM_err.append(ErrorRate_svm)
            SVM_time.append(time / float(testCount))

            # 3. AdaBoost
            ada_real, ErrorRate_ada1, time = c_2.Adaboost_error(mul, train_mood_array, label, test_word_array,
                                                               test_word_arrayLabel)
            print('Adaboost错误率为 %f' % ErrorRate_ada1)
            ada_real_err.append(ErrorRate_ada1)
            adaboost_time.append(time/ float(testCount))

            print()

        print("二分类平均错误率为：")
        ave_bayes = c_2.cal_average(Bayes_error)
        ave_SVM = c_2.cal_average(SVM_err)
        ave_ada = c_2.cal_average(ada_real_err)
        print("Bayes:", ave_bayes)
        print("SVM:", ave_SVM)
        print("Adaboost:", ave_ada)

        print("二分类平均时间为：")
        ave_bayes_time = c_2.cal_average(bayes_time)
        ave_SVM_time = c_2.cal_average(SVM_time)
        ave_ada_time = c_2.cal_average(adaboost_time)
        print("Bayes:", ave_bayes_time)
        print("SVM:", ave_SVM_time)
        print("Adaboost:", ave_ada_time)
        print()

        # 利用折线图显示算法的错误率
        lw = 2
        fig = plt.figure()
        gs = gridspec.GridSpec(2, 1, height_ratios=[4, 1])
        colors = [plt.cm.Spectral(each) for each in np.linspace(0, 1, 5)]
        ax1 = fig.add_subplot(gs[0])
        ax1.plot(Bayes_error, lw=lw, label='Bayes_error')
        ax1.plot(SVM_err, lw=lw, label='SVM_error')
        ax1.plot(ada_real_err, lw=lw, label='AdaBoost_error')
        ax1.set_xlabel('迭代次数')
        ax1.set_ylabel('错误率')
        ax1.set_title('二分类算法错误率对比')
        leg = ax1.legend(loc='lower center', fancybox=True, ncol=3, fontsize=8.5)
        leg.get_frame().set_alpha(0.7)

        ax2 = fig.add_subplot(gs[1])
        ax2.set_title("多分类算法对比")
        col_labels = ['Bayes', 'SVM', 'Adaboost']
        row_labels = ['平均错误率', '平均运行时间']
        table_vals = [[ave_bayes, ave_SVM, ave_ada], [ave_bayes_time, ave_SVM_time, ave_ada_time]]

        # colWidths 控制列宽，参数是一个长度和列数相同的list,整个形状的长度为1   rowLabels 行标签    loc 位置右上角
        ax2.axis('tight')
        ax2.axis('off')
        the_table = ax2.table(cellText=table_vals, colWidths=[0.3] * 3, rowLabels=row_labels, colLabels=col_labels,
                              loc='center')
        the_table.auto_set_font_size(value=True)
        fig.subplots_adjust(hspace=0.5)
        plt.savefig('二分类.jpg')
        plt.show()
        return 0

    def file_m_class(self, event):
        n_estimators = 500
        learning_rate = 1.

        multi_bayes_error = []
        multi_adaboost_error = []
        multi_SVM_error = []

        multi_bayes_time = []
        multi_adaboost_time = []
        multi_SVM_time = []
        for m in range(1, 11):
            print('第 %d 次迭代' % m)
            train_mood_array, label, test_word_array, test_word_arrayLabel, vocabList, testCount = self.load_text("train")

            # 1. 利用多项式贝叶斯进行分类并计算错误率
            count, multi_bayes, time = c_m.Multinomial_Bayes(train_mood_array, label, test_word_array, test_word_arrayLabel)
            print("多项式贝叶斯错误率：", count / float(testCount))
            multi_bayes_error.append(count / float(testCount))
            multi_bayes_time.append(time / float(testCount))

            # 2. 利用Adaboost进行分类并计算错误率
            a_error, time = c_m.Multinomial_Adaboost(n_estimators,multi_bayes, learning_rate, n_estimators, "SAMME.R",
                                                     train_mood_array, label, test_word_array, test_word_arrayLabel)
            print("Adaboost错误率：", a_error)
            multi_adaboost_error.append(a_error)
            multi_adaboost_time.append(time / float(testCount))

            # 3. 利用SVM进行分类并计算错误率
            tmp ,time = c_m.Multinomial_SVM(train_mood_array, label, test_word_array, test_word_arrayLabel)
            s_error = tmp/ testCount
            print("SVM错误率：", s_error)
            multi_SVM_error.append(s_error)
            multi_SVM_time.append(time / float(testCount))

            print()

        print("多分类平均错误率为：")
        ave_bayes = c_m.cal_average(multi_bayes_error)
        ave_SVM = c_m.cal_average(multi_SVM_error)
        ave_ada = c_m.cal_average(multi_adaboost_error)
        print("Bayes:", ave_bayes)
        print("SVM:", ave_SVM)
        print("Adaboost:",ave_ada)

        print("多分类平均时间为：")
        ave_bayes_time =c_m.cal_average(multi_bayes_time)
        ave_adaboost_time = c_m.cal_average(multi_adaboost_time)
        ave_SVM_time = c_m.cal_average(multi_SVM_time)
        print("Bayes:", ave_bayes_time)
        print("SVM:", ave_SVM_time)
        print("Adaboost:", ave_adaboost_time)

        print()

        # 画图
        mpl.rcParams['font.sans-serif'] = ['SimHei']
        fig = plt.figure()
        gs = gridspec.GridSpec(2, 1, height_ratios=[4, 1])
        colors = [plt.cm.Spectral(each) for each in np.linspace(0, 1, 5)]

        # 图像显示
        ax1 = fig.add_subplot(gs[0])
        ax1.set_title("多分类算法错误率对比")
        ax1.plot(multi_bayes_error, label='MultinomialNB')
        ax1.plot(multi_adaboost_error, label='Adaboost')
        ax1.plot(multi_SVM_error, label='SVM')
        ax1.set_xlabel('迭代次数')
        ax1.set_ylabel('错误率')
        leg = ax1.legend(loc='lower center', fancybox=True, ncol=3, fontsize=8.5)
        leg.get_frame().set_alpha(0.7)

        # 表格显示
        ax2 = fig.add_subplot(gs[1])
        ax2.set_title("多分类算法对比")
        col_labels = ['Bayes', 'SVM', 'Adaboost']
        row_labels = ['平均错误率', '平均运行时间']
        table_vals = [[ave_bayes,ave_SVM,ave_ada], [ave_bayes_time,ave_adaboost_time,ave_SVM_time]]
        # colWidths 控制列宽，参数是一个长度和列数相同的list,整个形状的长度为1   rowLabels 行标签    loc 位置右上角
        ax2.axis('tight')
        ax2.axis('off')
        the_table = ax2.table(cellText=table_vals, colWidths=[0.3] * 3 , rowLabels=row_labels,colLabels=col_labels,
                              loc='center')
        the_table.auto_set_font_size(value=True)
        fig.subplots_adjust(hspace=0.5)
        plt.savefig('多分类.jpg')
        plt.show()
        return 0

    def test_file_2_class(self, event):
        num_bayes = 0
        num_SVM = 0
        num_Adaboost = 0
        test_word_array, test_word_arrayLabel= self.load_text("test")

        muljob = joblib.load('../model/two_class_Bayes.pkl')
        result_bayes = muljob.predict(test_word_array)
        for i in range(len(result_bayes)):
            if result_bayes[i] != test_word_arrayLabel[i] and test_word_arrayLabel[i] != 3:
                num_bayes = num_bayes+1
        print('多项式Bayes错误率为 %f' % (num_bayes/len(result_bayes)))

        muljob = joblib.load('../model/two_class_SVM.pkl')
        result_SVM = muljob.predict(test_word_array)
        for i in range(len(result_SVM)):
            if result_SVM[i] != test_word_arrayLabel[i] and test_word_arrayLabel[i] != 3:
                num_SVM = num_bayes + 1
        print('SVM错误率为 %f' % (num_SVM / len(result_SVM)))

        muljob = joblib.load('../model/two_class_Adaboost.pkl')
        result_Adaboost = muljob.predict(test_word_array)
        for i in range(len(result_Adaboost)):
            if result_Adaboost[i] != test_word_arrayLabel[i] and test_word_arrayLabel[i] != 3:
                num_Adaboost = num_Adaboost + 1
        print('Adaboost错误率为 %f' % (num_Adaboost / len(result_Adaboost)))

        fw = open('测试文件二分类对比结果.txt', 'w', encoding='utf-8')
        fw.write('多项式Bayes错误率为 %f' % (num_bayes/len(result_bayes)))
        fw.write('\nSVM错误率为 %f' % (num_SVM / len(result_SVM)))
        fw.write('\nAdaboost错误率为 %f' % (num_Adaboost / len(result_Adaboost)))
        fw.flush()
        fw.close()
        print('测试文件二分类对比结果.txt')
        return 0

    def test_file_m_class(self, event):
        num_bayes = 0
        num_SVM = 0
        num_Adaboost = 0
        test_word_array, test_word_arrayLabel = self.load_text("test")

        muljob = joblib.load('../model/multi_class_Bayes.pkl')
        result_bayes = muljob.predict(test_word_array)
        for i in range(len(result_bayes)):
            if result_bayes[i] != test_word_arrayLabel[i]:
                num_bayes = num_bayes + 1
        print('多项式Bayes错误率为 %f' % (num_bayes / len(result_bayes)))

        muljob = joblib.load('../model/multi_class_SVM.pkl')
        result_SVM = muljob.predict(test_word_array)
        for i in range(len(result_SVM)):
            if result_SVM[i] != test_word_arrayLabel[i]:
                num_SVM = num_bayes + 1
        print('SVM错误率为 %f' % (num_SVM / len(result_SVM)))

        muljob = joblib.load('../model/multi_class_Adaboost.pkl')
        result_Adaboost = muljob.predict(test_word_array)
        for i in range(len(result_Adaboost)):
            if result_Adaboost[i] != test_word_arrayLabel[i]:
                num_Adaboost = num_Adaboost + 1
        print('Adaboost错误率为 %f' % (num_Adaboost / len(result_Adaboost)))

        fw = open('测试文件多分类对比结果.txt', 'w', encoding='utf-8')
        fw.write('多项式Bayes错误率为 %f' % (num_bayes / len(result_bayes)))
        fw.write('\nSVM错误率为 %f' % (num_SVM / len(result_SVM)))
        fw.write('\nAdaboost错误率为 %f' % (num_Adaboost / len(result_Adaboost)))
        fw.flush()
        fw.close()
        print('测试文件多分类对比结果.txt')
        return 0

    def text_get(self, event):
        global text
        text = self.text_analysis.GetValue()
        print(text)
        return 0

    def two_Bayes(self, event):
        muljob = joblib.load('../model/two_class_Bayes.pkl')

        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        # 直接给出测试集的预测类别输出
        result = muljob.predict([tmp])
        # two_class_result.append(text)
        if result[0] == 1:
            two_class_result.append("\n贝叶斯二分类结果：积极")
            print("贝叶斯二分类结果：积极")
        else:
            two_class_result.append("\n贝叶斯二分类结果：消极")
            print("贝叶斯二分类结果：消极")
        return 0

    def two_SVM(self, event):
        clf = joblib.load('../model/two_class_SVM.pkl')

        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        result = clf.predict([tmp])
        # two_class_result.append(text)
        if result[0] == 1:
            print("SVM二分类结果：积极")
            two_class_result.append("\nSVM二分类结果：积极")
        else:
            print("SVM二分类结果：消极")
            two_class_result.append("\nSVM二分类结果：消极")
        return 0

    def two_Adaboost(self, event):
        clf = joblib.load('../model/two_class_adaboost.pkl')
        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        result = clf.predict([tmp])
        #two_class_result.append(text)
        if result[0] == 1:
            print("Adaboost二分类结果：积极")
            two_class_result.append("\nAdaboost二分类结果：积极")
        else:
            print("Adaboost二分类结果：消极")
            two_class_result.append("\nAdaboost二分类结果：积极")
        return 0

    def multi_Bayes(self, event):
        clf = joblib.load('../model/multi_class_bayes.pkl')
        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        result = clf.predict([tmp])
        if result[0] == 1:
            print("贝叶斯多分类结果：积极")
            multi_class_result.append("\n贝叶斯多分类结果：积极")
        elif result[0] == 2:
            print("贝叶斯多分类结果：消极")
            multi_class_result.append("\n贝叶斯多分类结果：消极")
        elif result[0] == 3:
            print("贝叶斯多分类结果：中性")
            multi_class_result.append("\n贝叶斯多分类结果：中性")
        return 0

    def multi_SVM(self, event):
        clf = joblib.load('../model/multi_class_SVM.pkl')
        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        result = clf.predict([tmp])
        if result[0] == 1:
            print("SVM多分类结果：积极")
            multi_class_result.append("\nSVM多分类结果：积极")
        elif result[0] == 2:
            print("SVM多分类结果：消极")
            multi_class_result.append("\nSVM多分类结果：消极")
        elif result[0] == 3:
            print("SVM多分类结果：中性")
            multi_class_result.append("\nSVM多分类结果：中性")
        return 0

    def multi_Adaboost(self, event):
        clf = joblib.load('../model/multi_class_adaboost.pkl')
        vocabList, line_cut = self.load_text("text")
        tmp = word.setOfWordsToVecTor(vocabList, line_cut)
        result = clf.predict([tmp])
        if result[0] == 1:
            print("Adaboost多分类结果：积极")
            multi_class_result.append("\nAdaboost多分类结果：积极")
        elif result[0] == 2:
            print("Adaboost多分类结果：消极")
            multi_class_result.append("\nAdaboost多分类结果：消极")
        elif result[0] == 3:
            print("Adaboost多分类结果：中性")
            multi_class_result.append("\nAdaboost多分类结果：中性")
        return 0


    def two_c_result(self,event):
        fw = open('二分类对比.txt', 'w', encoding='utf-8')
        for i in text:
            fw.write(i)
        for i in two_class_result:
            fw.write(i)
        fw.flush()
        fw.close()
        print("二分类对比.txt")
        return 0


    def multi_c_result(self,event):
        fw = open('多分类对比.txt', 'a', encoding='utf-8')
        for i in text:
            fw.write(i)
        for i in multi_class_result:
            fw.write(i)
        fw.flush()
        fw.close()
        print("多分类对比.txt")
        return 0


if __name__ == '__main__':
    app = wx.App(False)
    frame = Sentiment_analysis(None)
    frame.Show(True)

    # start the applications
    app.MainLoop()

