import numpy as np
from sklearn.externals import joblib
from sklearn.naive_bayes import MultinomialNB
from sklearn.metrics import zero_one_loss
from sklearn.ensemble import AdaBoostClassifier
from sklearn.svm import SVC
import time

# 计算平均错误率
def cal_average(error):
    n = len(error)
    sum_error = 0
    average_error = 0.0
    i = 0

    for i in range(n):
        sum_error += error[i]
    average_error = sum_error/n
    return average_error


# 计算贝叶斯分类错误个数
def Multinomial_Bayes(train_array, train_array_label, test_array, test_array_label):
    start_time = time.clock()
    multi_b = MultinomialNB()
    multi_b = multi_b.fit(train_array, train_array_label)
    joblib.dump(multi_b, '../model/multi_class_bayes.pkl')
    mul = joblib.load('../model/multi_class_bayes.pkl')

    result = mul.predict(test_array)
    count = 0
    for i in range(len(test_array)):
        type = result[i]
        if type != test_array_label[i]:
            count = count + 1
    end_time = time.clock()
    return count, mul,end_time - start_time


# 计算Adaboost分类错误率
def Multinomial_Adaboost(n_estimators,multi, l_rate, num, method, train_array, train_array_label, test_array,
                         test_array_label):
    start_time = time.clock()
    ada_real = AdaBoostClassifier(base_estimator=multi, learning_rate=l_rate, n_estimators=num, algorithm=method)
    ada_real.fit(train_array, train_array_label)
    joblib.dump(ada_real, '../model/multi_class_adaboost.pkl')

    ada_real_err = np.zeros((n_estimators,))

    # 计算错误率
    for i, y_pred in enumerate(ada_real.staged_predict(test_array)):
        ada_real_err[i] = zero_one_loss(y_pred, test_array_label)
    end_time = time.clock()
    return min(ada_real_err),end_time - start_time


# 计算SVM分类错误个数
def Multinomial_SVM(train_array, train_array_label, test_array, test_array_label):
    start_time = time.clock()
    clf = SVC(kernel='linear')
    clf.fit(np.array(train_array), np.array(train_array_label))
    joblib.dump(clf, '../model/multi_class_svm.pkl')
    clf = joblib.load('../model/multi_class_svm.pkl')
    result = []
    result = clf.predict(test_array)

    num = 0
    for j in range(len(result)):
        if result[j] != test_array_label[j]:
            num = num + 1
    end_time = time.clock()
    return num , end_time - start_time
